Voicer/WebApplication/Controllers/VotingController.cs
using System.Diagnostics;
using System.Threading.Tasks;
using BusinessLogicLayer.Abstraction.Extensions;
using BusinessLogicLayer.Abstraction.Services.VotingCommands;
using BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using WebApplication.Models;

namespace WebApplication.Controllers
{
    public class VotingController : Controller
    {
        private readonly ILogger<VotingController> _logger;

        private readonly IVotingService _votingService;

        public VotingController(ILogger<VotingController> logger, IVotingService votingService)
        {
            _logger = logger;
            _votingService = votingService;
        }

        public async Task<IActionResult> Index()
        {
            return View(await _votingService.GetAllVotingAsync(User.GetUserId()));
        }

        [Authorize]
        public async Task<IActionResult> Get([FromRoute] int id)
        {
            GetVotingDto getVotingDto = await _votingService.GetVotingAsync(id);


            getVotingDto.UserVoted = await _votingService.HasUserVotedAsync(id, User.GetUserId());

            return View(getVotingDto);
        }

        [Authorize]
        public IActionResult Delete([FromRoute] int id)
        {
            _votingService.DeleteAsync(new DeleteVotingDto
            {
                Id = id,
                User = User
            });

            return RedirectToAction("Index");
        }

        [Authorize]
        public IActionResult Add()
        {
            return View(new CreateVotingDto());
        }

        [Authorize]
        [HttpPost]
        public async Task<IActionResult> Add([FromForm] CreateVotingDto dto)
        {
            if (ModelState.IsValid)
            {
                int createdVotingId = await _votingService.AddAsync(dto, User);

                return RedirectToAction("Get", new {id = createdVotingId});
            }

            return View(dto);
        }

        [Authorize]
        public IActionResult Invite(int id)
        {
            return View(new InviteUserDto
            {
                VotingId = id
            });
        }

        [Authorize]
        [HttpPost]
        public async Task<IActionResult> Invite([FromForm] InviteUserDto dto)
        {
            if (ModelState.IsValid)
            {
                await _votingService.InviteAsync(dto);
                return RedirectToAction("Get", new {id = dto.VotingId});
            }

            return View(dto);
        }

        [Authorize]
        public async Task<IActionResult> Update([FromRoute] int id)
        {
            return View(await _votingService.GetVotingForUpdateAsync(id));
        }


        [Authorize]
        [HttpPost]
        public async Task<IActionResult> Update([FromForm] UpdateVotingDto dto)
        {
            if (ModelState.IsValid)
            {
                await _votingService.UpdateAsync(dto);

                return RedirectToAction("Get", new {id = dto.Id});
            }

            return View(dto);
        }

        [Authorize]
        public async Task<IActionResult> MakeVote([FromQuery] int votingOptionId)
        {
            var makeVoteDto = new MakeVoteDto
            {
                VotingOptionId = votingOptionId,
                User = User
            };
            await _votingService.MakeVoteAsync(makeVoteDto);

            return Redirect(Request.Headers["Referer"].ToString());
        }


        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel {RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier});
        }
    }
}

Voicer/WebApplication/Views/Voting/Add.cshtml
@model BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.CreateVotingDto;

@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}

<h1>New voting</h1>
<form asp-action="Add" method="post" data-toggle="validator" role="form">
    <partial name="_Voting"/>
</form>
<a asp-action="Index" class="btn btn-light">Back</a>

Voicer/WebApplication/Views/Voting/Get.cshtml
@using DataAccessLayer.Models.Votes.Enums
@model BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.GetVotingDto;

@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}
<div class="row justify-content-md-center">
    <div class="col-sm-9">
        <div class="row">
            <div class="col-sm">
                <h1>My awesome voting</h1>
            </div>
            <div class="col-sm">
                @if (Model.VotingStatus == VotingStatus.Active || Model.VotingStatus == VotingStatus.Upcoming)
                {
                    <a asp-action="Invite" asp-route-id="@Model.Id" class="btn btn-outline-secondary">Invite user</a>
                }

                @if (Model.VotingStatus == VotingStatus.Upcoming)
                {
                    <a asp-action="Update" asp-route-id="@Model.Id" class="btn btn-outline-secondary">Edit voting</a>
                }

                @if (Model.User.UserName == User.Identity.Name)
                {
                    <a asp-action="Delete" asp-route-id="@Model.Id" class="btn btn-danger">Remove voting</a>
                }
            </div>
        </div>
        <div class="row">
            <div class="col-sm-6">
                <div class="card shadow p-3 mb-5 bg-white rounded">
                    <div class="card-body">
                        <h5 class="card-title">Details</h5>
                        <h6 class="card-subtitle mb-2 text-muted">Description</h6>
                        <p class="card-text">@Model.Description</p>
                        <h6 class="card-subtitle mb-2 text-muted">Start Date</h6>
                        <p class="card-text">@Model.StartDate</p>
                        <h6 class="card-subtitle mb-2 text-muted">Partisipants count</h6>
                        <p class="card-text">@Model.Participants.Count</p>
                        <h6 class="card-subtitle mb-2 text-muted">Vote count</h6>
                        <p class="card-text">@Model.Votes.Count</p>
                    </div>
                </div>
            </div>


            <div class="col-sm-6">
                <div class="card shadow p-3 mb-5 bg-white rounded">
                    <div class="card-body">
                        <h5 class="card-title">Voting</h5>
                        <h6 class="card-subtitle mb-2 text-muted float-right">02d 04 h 59m</h6>


                        @if (Model.VotingStatus == VotingStatus.Active && !Model.UserVoted)
                        {
                            <partial name="_VotingStatusActive"/>
                        }
                        @if (Model.VotingStatus == VotingStatus.Active && Model.UserVoted)
                        {
                            <partial name="_VotingStatusActiveDoneVote"/>
                        }
                        @if (Model.VotingStatus == VotingStatus.Ended)
                        {
                            <partial name="_VotingStatusEnded"/>
                        }
                        @if (Model.VotingStatus == VotingStatus.Upcoming)
                        {
                            <partial name="_VotingStatusUpcoming"/>
                        }

                        @* <partial name="_VotingStatus" model="@Model.SubCategoryId" />  *@
                    </div>
                </div>
            </div>
        </div>
        <br>
        <form>
            <div class="row">
                <div class="col-sm-12">
                    <div class="card shadow p-3 mb-5 bg-white rounded">
                        <ul class="list-group list-group-flush">
                            <li class="list-group-item">Chat</li>
                            <li class="list-group-item">

                                <div id="message-template" style="display: none">
                                    <h6 class="card-subtitle mb-2 text-muted">{{userName}} - {{date}}</h6>
                                    <p class="card-text">{{text}}</p>
                                </div>

                                <div id="chatroom"></div>
                                <input type="hidden" value="@Model.ChatId" id="chatId"/>
                            </li>
                            <li class="list-group-item">
                                <div class="input-group mb-1" id="inputForm">

                                    <div class="col-sm-9">
                                        <input type="text" class="form-control" id="message" placeholder="Insert message text here">
                                    </div>

                                    <div class="col-sm">
                                        <input class="btn btn-outline-secondary" type="button" id="sendBtn" value="Send message"/>
                                        @* <button class="btn btn-outline-secondary" type="button" id="button-addon2">Send </button> *@
                                    </div>


                                </div>
                            </li>
                        </ul>
                    </div>
                </div>

            </div>
        </form>

    </div>
</div>

Voicer/WebApplication/Views/Voting/Index.cshtml
@model BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.GetAllVotingDto;
@{
    ViewData["Title"] = "Voting Page";
}
<div class="row">

    <div class="col-sm">
        <h1>List voting</h1>
    </div>
    <div class="col-sm">
        <a asp-controller="Voting" asp-action="Add" class="btn btn-success">+ New voting</a>
    </div>
</div>
<div class="row">
    <div class="input-group mb-3">
        <div class="input-group-prepend">
            <button class="btn btn-outline-secondary" type="button" id="button-addon1">Search</button>
        </div>
        <input type="text" class="form-control" placeholder="" aria-label="Example text with button addon" aria-describedby="button-addon1">
    </div>
</div>

<div>
    <h7>Upcoming voting</h7>
    <partial name="_AllVoting" model="@Model.UpcomingVoting"/>
</div>
<div>
    <h7>Active voting</h7>
    <partial name="_AllVoting" model="@Model.ActiveVoting"/>
</div>
<div>
    <h7>Closed voting</h7>
    <partial name="_AllVoting" model="@Model.ClosedVoting"/>
</div>

Voicer/WebApplication/Views/Voting/Invite.cshtml
@model BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.InviteUserDto;

@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}

<h1>Invite user</h1>

<form asp-action="Invite" method="post">

    <div class="form-group">
        <label asp-for="SerchUser">User Email</label>
        <input asp-for="SerchUser" class="form-control" placeholder="Email"/>
        <span asp-validation-for="SerchUser" class="text-danger"></span>

    </div>
    <input type="hidden" asp-for="VotingId"/>
    <br>

    <input type="submit" value="Invite" class="btn btn-success"/>
</form>
<a asp-action="Get" asp-route-id="@Model.VotingId" class="btn btn-light">Back</a>

Voicer/WebApplication/Views/Voting/Update.cshtml
@model BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.UpdateVotingDto;

@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}

<h1>Edit voting</h1>
<form asp-action="Update" method="post" asp-route-id="@Model.Id">
    <partial name="_Voting"/>
    <input type="hidden" asp-for="Id"/>
</form>
<a asp-action="Get" asp-route-id="@Model.Id" class="btn btn-light">Back</a>

Voicer/WebApplication/Views/Voting/_AllVoting.cshtml
@using BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos
@model ICollection<BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.VotingDto>



@foreach (VotingDto voting in Model)
{
    <div class="card">
        <div class="card-body">
            <div class="row">
                <a asp-action="Get" asp-route-id="@voting.Id">@voting.Name</a>
                <div class="col-sm">
                    <p>@voting.StartDate</p>
                    <p>@voting.EndDate</p>

                </div>
                <div class="col-sm">
                    <button type="button" class="btn btn-outline-danger">Delete</button>
                </div>

            </div>
        </div>
    </div>
}
  

Voicer/WebApplication/Views/Voting/_Voting.cshtml
@model BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.CreateVotingDto;

@* <div asp-validation-summary="All" class="validation text-danger"></div> *@
<div class="form-group">
    <label asp-for="Name">Title</label>
    <input asp-for="Name" class="form-control"/>
    <span asp-validation-for="Name" class="text-danger"></span>
</div>

<div class="form-group">
    <label asp-for="Description">Description</label>
    <textarea asp-for="Description" class="form-control"></textarea>
    <span asp-validation-for="Description" class="text-danger"></span>
</div>

<div class="form-group">
    <label asp-for="StartDate">Start date</label>
    @* <input asp-for="StartDate" type="date" class="form-control"  data-date-format="yyyy-mm-dd" data-time-format='hh:ii' placeholder="yyyy-mm-dd  hh:ii"/> *@
    <input asp-for="StartDate" class="form-control datepicker-here" data-timepicker="true" data-date-format="yyyy-mm-dd" data-time-format='hh:ii' placeholder="yyyy-mm-dd  hh:ii"/>
    <span asp-validation-for="StartDate" class="text-danger"></span>

</div>

<div class="form-group">
    <label asp-for="EndDate">End date</label>
    <input asp-for="EndDate" class="form-control datepicker-here" data-timepicker="true" data-date-format="yyyy-mm-dd" data-time-format='hh:ii' placeholder="yyyy-mm-dd  hh:ii"/>
    <span asp-validation-for="EndDate" class="text-danger"></span>
</div>

<div class="form-group">
    <small>
        <h9 class="card-subtitle mb-2 text-muted">Voting options</h9>
    </small>
    <div class="voting-options">
        <div class="row">

            <span style="display: none" id="voting-options-count">@Model.VotingOptions.Length</span>

            @foreach (int i in Enumerable.Range(0, Model.VotingOptions.Length))
            {
                <div class="col-sm-7 mt-2">
                    <input asp-for="VotingOptions[i].Name" class="form-control voting-option"/>
                    <span asp-validation-for="VotingOptions[i].Name" class="text-danger"></span>

                </div>
            }
            <div class="col-sm-7 mt-2 add-option-container">
                <input type="button" value="Add option" class="addPick btn btn-outline-secondary"/>
                <input type="button" value="Delete option" class="deletePick btn btn-outline-secondary"/>
            </div>

            <div class="col-sm-7 mt-2" id="voting-option-template" style="display: none">
                <input asp-for="VotingOptions[0].Name" value="" class="form-control"/>
            </div>

        </div>
    </div>
    <div class="mt-2">
        <input type="submit" value="Save" class="btn btn-success"/>
    </div>

</div>

Voicer/WebApplication/Views/Voting/_VotingStatusActive.cshtml
@using BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos
@using DataAccessLayer.Models.Votes
@model GetVotingDto;


<div class="col-sm-7 mt-2">
    
    @foreach (VotingOptionDto option in Model.VotingOptions)
    {
        <a asp-action="MakeVote" asp-route-votingOptionId="@option.Id" class="btn btn-outline-secondary">@(option.Name)</a>

    }
</div>

Voicer/WebApplication/Views/Voting/_VotingStatusActiveDoneVote.cshtml
@model BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.GetVotingDto;

<h6 class="card-subtitle mb-2 text-muted float-right">Thanks for voting! Results will be availble soon.</h6>

Voicer/WebApplication/Views/Voting/_VotingStatusEnded.cshtml
@using BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos
@model BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.GetVotingDto;
пройтиссь по всем воутин оптионам и в славаре достать по ключу голосаколво

@foreach (VotingOptionDto option in Model.VotingOptions)
{
    <p>@option.Name</p>
    <div class="progress">
        @{
            var votingOptionCount = Model.VoteCountByVotingOptionDto.VotingOptionCount;
            var count = votingOptionCount.GetValueOrDefault(option.Id);
            var percent = votingOptionCount.Values.Sum() * 100.0 / count;
        }
        <div class="progress-bar bg-success" role="progressbar" style="width: @percent%;" aria-valuenow="25" aria-valuemin="0" aria-valuemax="100">

        </div>

        @count
    </div>
}

Voicer/WebApplication/Views/Voting/_VotingStatusUpcoming.cshtml
@model BusinessLogicLayer.Abstraction.Services.VotingCommands.Dtos.GetVotingDto;

<h6 class="card-subtitle mb-2 text-muted float-right">Vote will be availble soon.</h6>